/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest{}

// AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest struct for AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest
type AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest struct {
	DestinationId *string `json:"destinationId,omitempty"`
	WriteMode     *string `json:"writeMode,omitempty"`
}

// NewAppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest instantiates a new AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest() *AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest {
	this := AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest{}
	return &this
}

// NewAppDestinationHubspotHubspotDestinationActionDestinationFieldsRequestWithDefaults instantiates a new AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppDestinationHubspotHubspotDestinationActionDestinationFieldsRequestWithDefaults() *AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest {
	this := AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest{}
	return &this
}

// GetDestinationId returns the DestinationId field value if set, zero value otherwise.
func (o *AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest) GetDestinationId() string {
	if o == nil || IsNil(o.DestinationId) {
		var ret string
		return ret
	}
	return *o.DestinationId
}

// GetDestinationIdOk returns a tuple with the DestinationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest) GetDestinationIdOk() (*string, bool) {
	if o == nil || IsNil(o.DestinationId) {
		return nil, false
	}
	return o.DestinationId, true
}

// HasDestinationId returns a boolean if a field has been set.
func (o *AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest) HasDestinationId() bool {
	if o != nil && !IsNil(o.DestinationId) {
		return true
	}

	return false
}

// SetDestinationId gets a reference to the given string and assigns it to the DestinationId field.
func (o *AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest) SetDestinationId(v string) {
	o.DestinationId = &v
}

// GetWriteMode returns the WriteMode field value if set, zero value otherwise.
func (o *AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest) GetWriteMode() string {
	if o == nil || IsNil(o.WriteMode) {
		var ret string
		return ret
	}
	return *o.WriteMode
}

// GetWriteModeOk returns a tuple with the WriteMode field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest) GetWriteModeOk() (*string, bool) {
	if o == nil || IsNil(o.WriteMode) {
		return nil, false
	}
	return o.WriteMode, true
}

// HasWriteMode returns a boolean if a field has been set.
func (o *AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest) HasWriteMode() bool {
	if o != nil && !IsNil(o.WriteMode) {
		return true
	}

	return false
}

// SetWriteMode gets a reference to the given string and assigns it to the WriteMode field.
func (o *AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest) SetWriteMode(v string) {
	o.WriteMode = &v
}

func (o AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.DestinationId) {
		toSerialize["destinationId"] = o.DestinationId
	}
	if !IsNil(o.WriteMode) {
		toSerialize["writeMode"] = o.WriteMode
	}
	return toSerialize, nil
}

type NullableAppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest struct {
	value *AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest
	isSet bool
}

func (v NullableAppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest) Get() *AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest {
	return v.value
}

func (v *NullableAppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest) Set(val *AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest(val *AppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest) *NullableAppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest {
	return &NullableAppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest{value: val, isSet: true}
}

func (v NullableAppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppDestinationHubspotHubspotDestinationActionDestinationFieldsRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
